
Eina_Bool _efl_canvas_proxy_source_set(Eo *obj, void *pd, Efl_Canvas_Object *src);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV(efl_canvas_proxy_source_set, Eina_Bool, 0, EFL_FUNC_CALL(src), Efl_Canvas_Object *src);

Efl_Canvas_Object *_efl_canvas_proxy_source_get(const Eo *obj, void *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_proxy_source_get, Efl_Canvas_Object *, NULL);

void _efl_canvas_proxy_source_clip_set(Eo *obj, void *pd, Eina_Bool source_clip);


static Eina_Error
__eolian_efl_canvas_proxy_source_clip_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_canvas_proxy_source_clip_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_proxy_source_clip_set, EFL_FUNC_CALL(source_clip), Eina_Bool source_clip);

Eina_Bool _efl_canvas_proxy_source_clip_get(const Eo *obj, void *pd);


static Eina_Value
__eolian_efl_canvas_proxy_source_clip_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_canvas_proxy_source_clip_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_proxy_source_clip_get, Eina_Bool, 0);

void _efl_canvas_proxy_source_events_set(Eo *obj, void *pd, Eina_Bool repeat);


static Eina_Error
__eolian_efl_canvas_proxy_source_events_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_canvas_proxy_source_events_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_proxy_source_events_set, EFL_FUNC_CALL(repeat), Eina_Bool repeat);

Eina_Bool _efl_canvas_proxy_source_events_get(const Eo *obj, void *pd);


static Eina_Value
__eolian_efl_canvas_proxy_source_events_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_canvas_proxy_source_events_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_proxy_source_events_get, Eina_Bool, 0);

Eina_Rw_Slice _efl_canvas_proxy_efl_gfx_buffer_buffer_map(Eo *obj, void *pd, Efl_Gfx_Buffer_Access_Mode mode, const Eina_Rect *region, Efl_Gfx_Colorspace cspace, int plane, int *stride);


Eina_Bool _efl_canvas_proxy_efl_gfx_buffer_buffer_unmap(Eo *obj, void *pd, Eina_Rw_Slice slice);


static Eina_Bool
_efl_canvas_proxy_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_CANVAS_PROXY_EXTRA_OPS
#define EFL_CANVAS_PROXY_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_canvas_proxy_source_set, _efl_canvas_proxy_source_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_proxy_source_get, _efl_canvas_proxy_source_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_proxy_source_clip_set, _efl_canvas_proxy_source_clip_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_proxy_source_clip_get, _efl_canvas_proxy_source_clip_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_proxy_source_events_set, _efl_canvas_proxy_source_events_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_proxy_source_events_get, _efl_canvas_proxy_source_events_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_buffer_map, _efl_canvas_proxy_efl_gfx_buffer_buffer_map),
      EFL_OBJECT_OP_FUNC(efl_gfx_buffer_unmap, _efl_canvas_proxy_efl_gfx_buffer_buffer_unmap),
      EFL_CANVAS_PROXY_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"source_clip", __eolian_efl_canvas_proxy_source_clip_set_reflect, __eolian_efl_canvas_proxy_source_clip_get_reflect},
      {"source_events", __eolian_efl_canvas_proxy_source_events_set_reflect, __eolian_efl_canvas_proxy_source_events_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_canvas_proxy_class_desc = {
   EO_VERSION,
   "Efl.Canvas.Proxy",
   EFL_CLASS_TYPE_REGULAR,
   0,
   _efl_canvas_proxy_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_canvas_proxy_class_get, &_efl_canvas_proxy_class_desc, EFL_CANVAS_IMAGE_INTERNAL_CLASS, NULL);
